# Dynamic Regions

`New-UDDynamic` allows you to define a dynamic region. Pages themselves are dynamic in nature. This means that every time a page is loaded, it runs the PowerShell for that page. Sometimes, you may want to reload a section of a page rather than the whole page itself. This is when you will want to use dynamic regions.

## Basic Dynamic Region

This dynamic region reloads when the button is clicked.

```
New-UDDashboard -Title "Hello, World!" -Content {
    New-UDDynamic -Id 'date' -Content {
        New-UDTypography -Text "$(Get-Date)"
    }

    New-UDButton -Text 'Reload Date' -OnClick { Sync-UDElement -Id 'date' }
}
```

![Reload on button click](/files/-MH1kdP3DzX7TPUJM5aW)

## Auto Refresh

Dynamic regions enable the ability to auto refresh components after a certain amount of time. The entire region's script block will be run when autorefreshing.

{% hint style="info" %}
If you have multiple related components that use the same data, consider putting them in the same dynamic region to improve performance.
{% endhint %}

```
    New-UDDynamic -Id 'date' -Content {
        New-UDTypography -Text "$(Get-Date)" -Variant h3
        New-UDTypography -Text "$(Get-Random)" -Variant h3
    } -AutoRefresh -AutoRefreshInterval 1
```

![Auto refresh dynamic region](/files/-MH1lb8O1Sr7jvmr22VJ)

## Loading Component

Sometimes refreshing a dynamic component may take some time. For example, if you are querying another service's REST API or a data. Dynamic regions support configuration of the component that shows when the region is reloading. By default, nothing is shown. This can be any Universal Dashboard component.

```
    New-UDDynamic -Content {
        Start-Sleep -Seconds 3
        New-UDTypography -Text "Done!"
    } -LoadingComponent {
        New-UDProgress -Circular
    }
```

![Loading component for dynamic region](/files/-MH1mcBy9s7oZECy02iE)

## API

### New-UDDynamic&#x20;

Defines a dynamic region on a page.&#x20;

| Name                | Type        | Description                                                                           | Required |
| ------------------- | ----------- | ------------------------------------------------------------------------------------- | -------- |
| Id                  | string      | Unique identifier for this region                                                     | false    |
| ArgumentList        | object\[]   | Arguments to pass to the region. Available within the -Content by using $ArgumentList | false    |
| Content             | ScriptBlock | The content to load within the dynamic region                                         | true     |
| AutoRefresh         | Switch      | Whether this dynamic region will refresh on an interval                               | false    |
| AutoRefreshInterval | int         | The number of seconds between auto refreshes.                                         | false    |
| LoadingComponent    | ScriptBlock | A component to display when the dynamic is loading                                    | false    |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.powershelluniversal.com/v1/dashboard/components/dynamic-regions.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
